﻿using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Reflection;
using System.Net;
using System.Configuration;
using System.Data.SqlClient;
using System.Data;
using Syncfusion.JavaScript;
using Syncfusion.EJ.Export;
using Syncfusion.XlsIO;
using MvcApplication66.Models;
using System.Threading;
using System.Reflection.Emit;

namespace MvcApplication66.Controllers
{
    public class HomeController : Controller
    {

        public ActionResult Index()
        {
            IEnumerable data = new MyDataContextDataContext()._30000Records.Take(2000).ToList();
            ViewBag.datasource = data;
            return View();
        }
        public void ExportToExcel(string GridModel)
        {
            ExcelExport exp = new ExcelExport();
            var DataSource = new MyDataContextDataContext()._30000Records.Take(2000).ToList();
            GridProperties obj = (GridProperties)Syncfusion.JavaScript.Utils.DeserializeToModel(typeof(GridProperties), GridModel);
            exp.Export(obj, DataSource, "Export.xlsx", ExcelVersion.Excel2010, false, false, "flat-saffron");
        }
        public void ExportToWord(string GridModel)
        {
            WordExport exp = new WordExport();
            var DataSource = new MyDataContextDataContext()._30000Records.Take(2000).ToList();
            GridProperties obj = (GridProperties)Syncfusion.JavaScript.Utils.DeserializeToModel(typeof(GridProperties), GridModel);
            exp.Export(obj, DataSource, "Export.docx", false, false, "flat-saffron");
        }
        public void ExportToPdf(string GridModel)
        {
            PdfExport exp = new PdfExport();
            var DataSource = new MyDataContextDataContext()._30000Records.Take(2000).ToList();
            GridProperties obj = (GridProperties)Syncfusion.JavaScript.Utils.DeserializeToModel(typeof(GridProperties), GridModel);
            exp.Export(obj, DataSource, "Export.pdf", false, false, "flat-saffron");
        }
        //private GridProperties ConvertGridObject(string gridProperty)
        //{
        //    JavaScriptSerializer serializer = new JavaScriptSerializer();
        //    IEnumerable div = (GridProperties)Syncfusion.JavaScript.Utils.DeserializeToModel(typeof(GridProperties), GridModel); ;
        //    GridProperties gridProp = new GridProperties();
        //    foreach (KeyValuePair<string, object> ds in div)
        //    {
        //        var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
        //        if (property != null)
        //        {
        //            Type type = property.PropertyType;
        //            string serialize = serializer.Serialize(ds.Value);
        //            object value = serializer.Deserialize(serialize, type);
        //            property.SetValue(gridProp, value, null);
        //        }
        //    }
        //    return gridProp;
        //}
    }
}